var arcFaceUtil={
    module:null,
    brightnessUtil:null,
    brightness:1,//屏幕亮度
    rgbThreshold:0.5,//活体检测阈值，
    debug:true,
    similarThreshold_android:0.72,
    similarThreshold_ios:0.5,
    openFacePage:false,//是否打开了人脸识别页面
    log:function(str){
      if(this.debug)console.log('arcFaceUtil: '+str)
    },
    /**
     * 初始化
     */
    init:function () {
        this.module=api.require('ArcFaceEdition');
        if(!this.module)alert('请添加模块后编译');
        this.setSimilarThreshold(arcFaceUtil['similarThreshold_'+ api.systemType]);
        if(api.systemType==='ios')this.setLivenessDetect(false);
        this.brightnessUtil = api.require('brightnessUtil');
        this.brightnessUtil.getBrightness(function(ret) {
            if (ret) {
                arcFaceUtil.brightness=ret.brightness
            }
        });

    },
    active:function(){
        return new Promise(function (resolve,reject) {
            arcFaceUtil.module.active(function (ret,err) {
                arcFaceUtil.log('active'+JSON.stringify(ret)+',err:'+JSON.stringify(err));
                if(ret.status)resolve();
                else reject({key:'activeErr',value:JSON.stringify(err)});
            })
        })
    },
    /**
     * 添加用户
     * @param userId 用户id
     * @param faceImage 用户照片本地地址
     */
    addUser:function (userId,faceImage) {
        this.log('begin AddUser['+arcFaceUtil['similarThreshold_'+ api.systemType]+']:'+userId+','+faceImage);
        return new Promise(function (resolve,reject) {
            arcFaceUtil.module.addUser({
                userId:userId,faceImage:faceImage,fazhi:arcFaceUtil['similarThreshold_'+ api.systemType]
            },function (ret,err) {
                arcFaceUtil.log('addUser-['+userId+']'+JSON.stringify(ret)+',err:'+JSON.stringify(err));
                if(ret.status)resolve();
                else reject({key:'addUserErr',velue:JSON.stringify(err)});
            })
        })
    },
    countUser:function () {
        return new Promise(function (resolve) {
            arcFaceUtil.module.countUser(function (ret) {
                arcFaceUtil.log('countUser:'+JSON.stringify(ret));
                resolve(ret.status?ret.count:0)
            })
        });
    },
    clearAllUser:function () {
        arcFaceUtil.log('clearAllUser');
        return new Promise(function (resolve) {
            arcFaceUtil.module.clearAllUser(function (ret) {
                arcFaceUtil.log('clearAllUser-'+JSON.stringify(ret));
                resolve();
            })
        })
    },
    removeUser:function (userId) {
        return new Promise(function (resolve) {
            arcFaceUtil.module.removeUser({userId:userId},function (ret,err) {
                arcFaceUtil.log('removeUser-['+userId+']'+JSON.stringify(ret)+','+JSON.stringify(err));
                resolve();
            })
        })
    },
    getUser:function (userId) {
        return new Promise(function (resolve,reject) {
            arcFaceUtil.module.getUser({
                userId:userId
            },function (ret,err) {
                arcFaceUtil.log('getUser['+userId+']-'+JSON.stringify(ret));
                if(ret.status)resolve(ret);
                else reject({key:'noFaceInfo',value:JSON.stringify(err)})
            })
        });
    },
    /**
     *
     * @param cameraId 相机 1-前置，0-后置
     * @param rgbThreshold 开启活体检测时的阈值
     */
    openCompare:function (cameraId,rgbThreshold,type) {
        this.brightnessUtil.setBrightness({brightness: 1});
        arcFaceUtil.log('openCompare'+cameraId+','+rgbThreshold+','+type);
        return new Promise(function (resolve, reject) {
            arcFaceUtil.module.openCompare({
                fixed: true,
                cameraId:cameraId,
                rgbThreshold:rgbThreshold,
            },function (ret,err) {
                arcFaceUtil.log('openCom:'+JSON.stringify(ret)+','+JSON.stringify(err));
                if(ret.status){
                    arcFaceUtil.openFacePage=true;
                    api.openFrame({
                        name: 'arcFaceFrame',
                        url: 'widget://html/face_mask.html',
                        pageParam: {type: type},
                    });
                    arcFaceUtil.playRound(type);
                    resolve();
                }else{
                    reject(err);
                }
            })
        })
    },
    /**
     * 播放声音
     */
    playRound:function(type){
        if(this.openFacePage){
            api.startPlay({
                path: 'widget://res/' + type + '.mp3'
            }, function (ret) {
                setTimeout(function () {
                    arcFaceUtil.playRound(type)
                }, 300)
            });
        }
    },
    /**
     * 关闭人脸识别页面
     */
    closeCompare:function () {
        this.module.closeCompare();
        this.openFacePage=false;
        this.brightnessUtil.setBrightness({brightness: this.brightness});
        this.removeFacepassListener();
        api.closeFrame({
            name: 'arcFaceFrame'
        });
        Util.publish('closeCompare');
    },
    addFacepassListener:function (callback) {
        this.module.addFacepassListener(callback)
    },
    removeFacepassListener:function () {
        this.log("removeFacepassListener")
        this.module.removeFacepassListener();
    },
    takePhoto:function () {
        this.log('takePhoto');
        this.module.takePhoto(function (ret) {
            arcFaceUtil.log('takePhoto:'+JSON.stringify(ret));
            Util.publish('takePhoto',ret)
        })
    },
    setLivenessDetect:function (flag) {
        this.module.setLivenessDetect({enable:flag});
    },
    setSimilarThreshold:function (fazhi) {
        arcFaceUtil['similarThreshold_'+ api.systemType]=fazhi;
        this.module.setSimilarThreshold({fazhi:fazhi},function (ret) {
            arcFaceUtil.log('setSimilarThreshold:['+fazhi+']-'+JSON.stringify(ret))
        })
    },
    compareSignature:function (signature1,signature2) {
        arcFaceUtil.log(signature1+'\n s2:'+signature2);
        return new Promise(function (resolve){
            if(!signature1 || !signature2)return resolve(false);
            if(signature1===signature2)return resolve(true);
            arcFaceUtil.module.compareSignature({
                signature1:signature1,signature2:signature2,fazhi:arcFaceUtil['similarThreshold_'+ api.systemType]
            },function (ret) {
                // alert(JSON.stringify(ret));
                arcFaceUtil.log('signature:'+JSON.stringify(ret));
                resolve(ret.isSame||false)
            })
        });

    },
    setRgbThreshold:function (int) {
        this.rgbThreshold=int;
    }
};
