var ls = (/android/gi).test(navigator.appVersion) ? os.localStorage() : window.localStorage;
// 设置存储
function _setStorage(key, value) {
    if (arguments.length === 2) {
        var v = value;
        if (typeof v == 'object') {
            v = JSON.stringify(v);
            v = 'obj-' + v;
        } else {
            v = 'str-' + v;
        }
        ls.setItem(key, v);
    }
}

// 获取存储
function _getStorage(key) {
    var v = ls.getItem(key);
    if (!v) {
        return null;
    } else if (v.indexOf('obj-') === 0) {
        v = v.slice(4);
        return JSON.parse(v);
    } else if (v.indexOf('str-') === 0) {
        return v.slice(4);
    }
};

// 移除存储
function _removeStorage(key) {
    if (key) {
        ls.removeItem(key);
    }
}

//清除所有存储
function _clearStorage() {
    ls.clear();
}
//添加原型方法 取消表情
String.prototype.emoji = function () {
    var regStr = /[^a-zA-Z0-9\u4e00-\u9fa5_,?!:;…~\(\)<>{}\[\]，。；‘“【】、——《》？*]/ig;
    return this.replace(regStr, '');
};
//自定义原型方法不能被枚举
Object.defineProperty(String.prototype, 'emoji', {enumerable: false});
//对象继承---浅拷贝
Object.extend = function (des, sou) {
    var obj = JSON.parse(JSON.stringify(des));
    for (var key in sou) {
        obj[key] = sou[key]
    }
    return obj;
};
// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
// 例子：
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
Date.prototype.Format = function (fmt) { //author: meizz
    var o = {
        "M+": this.getMonth() + 1,                 //月份
        "d+": this.getDate(),                    //日
        "h+": this.getHours(),                   //小时
        "m+": this.getMinutes(),                 //分
        "s+": this.getSeconds(),                 //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};

// 小提示
function _toast(para) {
    api.toast(_extendObj({
        msg: '',
        duration: 2000,
        location: 'middle',
        global: false
    }, typeof para === 'object' ? para : {msg: para}));
}
//关闭win
function _closeWin(name) {
    if (typeof name === 'number') {
        setTimeout(function () {
            api.closeWin();
        }, name)
    } else {
        api.closeWin({name: name});
    }
}

/**
 * 双击退出应用
 * @private
 */
function _twoClickCloseApp() {
    if (api.systemType === 'android') {
        var mkeyTime = new Date().getTime();
        api.addEventListener({
            name: 'keyback'
        }, function () {
            console.log("keyback")
            if ((new Date().getTime() - mkeyTime) > 2000) {
                mkeyTime = new Date().getTime();
                _toast({
                    msg: '再按一次退出APP',
                    location: 'bottom'
                });
            } else {
                api.closeWidget({silent: true});
            }
        })
    }
}

// 弹窗
function _alert() {
    var lang = _getPrefs('language') || "zh_CN",
        defaults = {
            title: /zh|cn/i.test(lang) ? "提示" : "Tips",
            msg: api.winName,
            buttons: [/zh|cn/i.test(lang) ? "确认" : "OK"],
        }, para = arguments[0], callback = arguments[1];
    if (_judgeType(para, 'object')) {
        for (var k in para) {
            defaults[k] = para[k]
        }
    } else if (typeof para === "string" && para) {
        defaults.msg = para;
    }
    api.alert(defaults, function () {
        if (_judgeType(callback, 'function')) callback();
    })
}
/**
 * 封装api.confirm方法,接收最长3个参数,最少1个参数
 * @param para:第一个参数,选填:展示的title,msg,buttons
 * @param callback:必填,第一/第二参数,确定的回调函数
 * @param cancelBack:选填,第二/第三参数,取消/拒绝的回调函数
 */
function _confirm() {
    var cn = /zh|cn/i.test(_getStorage('language') || "cn"),
        defaults = {
            title: cn ? "提示" : "Tips",
            msg: cn ? "是否确定" : "Whether to confirm?",
            buttons: cn ? ['确定', '取消'] : ['Confirm', 'Cancel'],
        }, para, callback, cancelBack;
    for (var i = 0; i < arguments.length; i++) {
        switch (_judgeType(arguments[i])) {
            case "[object object]":
                para = arguments[i];
                for (var k in para) {
                    defaults[k] = para[k]
                }
                break;
            case "[object string]":
                defaults.msg = arguments[i]
                break;
            case "[object function]":
                if (callback) {
                    cancelBack = arguments[i];
                } else {
                    callback = arguments[i];
                }
        }
    }
    api.confirm(defaults, function (ret, err) {
        if (ret.buttonIndex === 1) {
            callback && callback()
        } else {
            cancelBack && cancelBack()
        }
    });
}
//打开遮罩层
function _showProgress(para) {
    var lang = _getStorage('language') || 'zh_CN',
        defaults = {
            style: 'default',
            animationType: 'fade',
            title: /zh|cn/ig.test(lang) ? "正在加载" : "Loading",
            text: /zh|cn/ig.test(lang) ? "请稍后..." : "Please Wait...",
            modal: true
        }
    if (_judgeType(para, 'object')) {
        for (var k in para) {
            defaults[k] = para[k]
        }
    } else if (typeof para === "string") {
        defaults.title = para
    }
    api.showProgress(defaults);
}

function _prompt() {
    var buttonsList = ['确定', '取消'];
    var title = '提醒';
    var lang = _getStorage('language') || 'zh_CN';
    if (lang.indexOf('en') > -1) {
        buttonsList = ['Confirm', 'Cancel'];
        title = 'Tips';
    }
    var setting = {
        title: title,
        buttons: buttonsList

    }
    var para = arguments[0];
    var success = arguments[1];
    var cancel = arguments[2];
    if (_judgeType(para, 'object')) {
        setting = $.extend(setting, para);
    }
    if (_judgeType(para, 'string')) {
        setting.msg = para;
    }
    api.prompt(setting, function (ret) {
        var text = ret.text;
        if (ret.buttonIndex == 1 && _judgeType(success, 'function')) {
            success(text);
        } else if (_judgeType(cancel, 'function')) {
            cancel();
        }
    });
}

var ajaxArr = [];
function _ajax(service, para, callback) {
    var serverAddress = api.getGlobalData({key: 'serverAddress'}),
        data = {values: {}, files: {}}, mask = para.mask, timeOut = para.timeOut || 10;
    delete para.timeOut;
    delete para.mask;
    for (var i = 0; i < ajaxArr.length; i++) {
        if (ajaxArr[i] === service + JSON.stringify(para)) return;
    }
    ajaxArr.push(service + JSON.stringify(para));
    if (mask) {
        api.showProgress({
            style: 'default',
            animationType: 'fade',
            title: '请求中',
            text: '请稍后...',
            modal: true
        });
    }
    for (var k in para) {
        if (k === 'file') data.files.file = para[k];
        else data.values[k] = para[k]
    }
    api.ajax({
        url: serverAddress + service,
        method: 'post',
        dataType: 'json',
        returnAll: false,
        data: data,
        timeOut: timeOut
    }, function (ret, err) {
        for (var i = 0; i < ajaxArr.length; i++) {
            if (ajaxArr[i] === service + JSON.stringify(para)) {
                ajaxArr.splice(i, 1);
                break;
            }
        }
        if (mask) api.hideProgress();
        if (!callback) return;
        //如果发生错误，有code 返回code，没有返回err代码，都没有返回99-网络错误
        if (err) return callback({status: false, code: 404});
        if (ret.status === false || ret.err > 0) {
            ret.status = false;
            ret.code = ret.code || ret.err;
            return callback(ret);
        }
        ret.status = true;
        callback(ret);
    });
};

function imageCache(url) {
    return new Promise(function (resolve, reject) {
        api.download({
            url: url + '-xuanzheng',
            cache: false,
            allowResume: true
        }, function (ret, err) {
            console.log(url+"-下载照片-"+JSON.stringify(ret))
            switch (ret.state) {
                case 1:
                    resolve(ret.savePath);
                    break;
                case 2:
                    reject({key: 'imageCacheFiled', value: JSON.stringify(err)});
                    break;
            }
        });
    });
}

function appUpdate(download) {
    api.confirm({
        title: '发现新版本,是否升级?',
        buttons: ['取消', '确定']
    }, function (ret) {
        switch (ret.buttonIndex) {
            case 1:
                _alert('请更新后再使用APP', function () {
                    api.closeWidget({silent: true});
                });
                break;
            case 2:
                if (api.systemType === 'ios') {
                    api.installApp({
                        appUri: download
                    })
                } else {
                    //安卓下载安装包
                    api.showProgress({
                        style: 'default',
                        animationType: 'fade',
                        title: '升级下载',
                        text: '请稍后...',
                        modal: true
                    });
                    api.download({
                        url: download, report: false, cache: false, allowResume: false
                    }, function (ret) {
                        api.hideProgress();
                        if (ret.state === 1) {
                            api.installApp({appUri: ret.savePath});
                        } else {
                            _alert('下载失败,请稍后重试', function () {
                                api.closeWidget({silent: true});
                            });
                        }
                    });
                }
        }
    })
}
function _openFrame(para) {
    var defaults = {
        scrollToTop: true,
        bounces: false,
        reload: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: true,
        scaleEnabled: false,
        allowEdit: false,
    }
    if (!_judgeType(para, "object")) return _alert("参数错误");
    for (var k in para) {
        defaults[k] = para[k]
    }
    api.openFrame(defaults);
}
//存储偏好设置数据
function _setPrefs(key, v) {
    if (v === undefined || v === null || v === '') return alert('值无效')
    if (typeof key !== 'string') return alert('格式错误');
    switch (typeof v) {
        case 'object':
            v = 'obj-' + JSON.stringify(v);
            break;
        case 'string':
            v = 'str-' + v;
            break;
        case 'number':
            v = 'num-' + v;
            break;
        case 'boolean':
            v = 'boo-' + (v ? 1 : 0)
            break;
        default:
            v = 'und-' + v;
            break;
    }
    api.setPrefs({key: key, value: v})
}

//读取偏好设置数据
function _getPrefs(key) {
    if (!key || typeof key !== 'string') return alert('格式错误')
    var v = api.getPrefs({
        key: key,
        sync: true
    });
    if (v === '') return null;
    switch (v.substr(0, 4)) {
        case 'obj-':
            v = JSON.parse(v.substr(4));
            break;
        case 'str-':
            v = v.substr(4);
            break;
        case 'num-':
            v = Number(v.substr(4));
            break;
        case 'boo-':
            v = v.substr(4) === '1';
            break;
        default:
            v = v.substr(4)
            break;
    }
    return v;
}

//删除偏好设置数据
function _removePrefs(key) {
    if (key) {
        api.removePrefs({
            key: key
        });
    }
}
function _judgeType(obj, type) {
    if (arguments.length === 2) {
        type = type.toLowerCase();
        return Object.prototype.toString.call(obj).toLowerCase() === '[object ' + type + ']';
    } else {
        return Object.prototype.toString.call(obj).toLowerCase()
    }
}
function _openTabWin(para) {
    var defaults = _extendObj({
        name: '',
        url: '',
        title: '',
        vScrollBarEnabled: false,
        slidBackEnabled:false,
        scrollEnabled:false,
        navigationBar: {
            background:"#fff",
            color:"#585858",
            shadow: "#fff",
            height: 45,
            fontSize: 18,
            fontWeight: 'blod',
            leftButtons: [{iconPath: 'widget://image/tabbar/back.png', text: '返回', color: '#585858', fontSize: 14}]
        }
    }, para);
    if (!defaults.name) defaults.name = defaults.url.replace(/\S+\/|\.html/g, "");
    api.openTabLayout(defaults)
}
function _extendObj(obj, dst) {
    for (var k in dst) {
        if (_judgeType(dst[k], 'object')) {
            obj[k] = _extendObj(obj[k] || {}, dst[k])
        } else {
            obj[k] = dst[k];
        }
    }
    return obj;
}
function openTabItem() {

}