//加载template-web
if (!window.template) {
    var jshtml = document.querySelectorAll('script');
    for (var i = 0; i < jshtml.length; i++) {
        var path = jshtml[i].getAttribute('src');
        if (path) {
            path = path.substring(0, path.lastIndexOf('/') + 1);
            document.write("<script src='" + path + "template-web.js'></script>");
            break;
        }
    }
}
window.DbUtil = {
    dbName:'face',
    dbPath:'fs://arcFace1.db',
    debug: true,
    logType:0,
    logClass:'error',
    module: null,
    tpl: {
        addFace:'insert into faceList(name,phone,faceFeature,faceCacheUrl,iden) values("{{name}}","{{phone}}","{{faceFeature}}","{{faceCacheUrl}}",{{iden}})',
        findMyEqpt:'select eqptId,name,customName,privateKey,privateTime,bleType,managerPhone phone,lastUpdate from myEqptList where managerPhone="{{phone}}" {{if name}}and name="{{name}}"{{/if}}',
        findEqptFaceMap:'select m.phone,ifnull(name,"未知") name,ifnull(m.iden,1) iden,ifnull(faceFeature,"") faceFeature,ifnull(faceCacheUrl,"") faceCacheUrl from eqptFaceMap m left join faceList f on m.phone=f.phone  where termCode="{{eqptName}}" {{if phone}} and m.phone="{{phone}}"{{/if}}'
    },
    assembly: function (sqlKey, data) {
        var sqlStr, sqlTpl = this.tpl[sqlKey]||sqlKey;
        if (!data) return sqlTpl;
        try {
            sqlStr = template.render(sqlTpl, data);
            return sqlStr;
        } catch (e) {
            return sqlKey
        }
    },
    find: function (sqlKey, data) {
        if (!this.module) this.module = api.require('db');
        var sql = this.assembly(sqlKey, data);
        var res = this.module.selectSqlSync({name: this.dbName, sql: sql});
        if (this.debug) console.log('find_[' + sql + ']-status:' + (res.status ? res.status : res.msg));
        if (res.status) {
            return res.data;
        } else {
            return [];
        }
    },
    findFirst: function (sqlKey, data) {
        var res = this.find(sqlKey, data);
        if (res.length) {
            return res[0]
        } else {
            return null;
        }
    },
    querySqlSync: function (sqlKey, data) {
        var sql = this.assembly(sqlKey, data);
        if (!this.module) this.module = api.require('db');
        var res = this.module.executeSqlSync({
            name: this.dbName, sql: sql
        });
        if (this.debug) console.log('querySqlSync_[' + sql + ']:' + (res.status?'ok':JSON.stringify(res)));
        return res.status
    },
    querySql: function (sqlKey, data, callback) {
        if (!this.module) this.module = api.require('db');
        if (arguments.length === 2) {
            switch (typeof arguments[1]) {
                case 'function':
                    callback = arguments[1];
                    break;
                case 'object':
                    data = arguments[1];
                    break;
            }
        }
        var sql = this.assembly(sqlKey, data);
        this.module.executeSql({
            name: this.dbName, sql: sql
        }, function (ret, err) {
            if (DbUtil.debug) console.log('querySql_[' + sql + ']:' + (ret.status ? 'true' : err.msg));
            callback && callback(ret, err)
        });
    },
    initDB: function () {
        this.openDB();
        this.querySqlSync('create table if not exists myInfo(phone text primary key,faceFeature text,name text,faceUrl text,cacheUrl text)');
        this.querySqlSync('create table if not exists operatorEqpt(phone text,name text,lastUpdate int,faceFeature text,faceVerify int,iden int)');
        this.querySqlSync('create table if not exists myEqptList(eqptId INTEGER primary key autoincrement,name text,customName text,bleType int default 1,loginPassword text,managerPassword text,managerPhone text,lastUpdate int default 0)');
        this.querySqlSync('create table if not exists faceList(id INTEGER primary key autoincrement,phone text primary key,name text,faceFeature text,faceUrl text,cacheUrl text,iden int,managerPhone text)');
        this.querySqlSync('create table if not exists eqptFaceMap(termCode text,userId int,iden int)');
    },
    openDB: function () {
        this.module = api.require('db');
        this.module.openDatabaseSync({name: this.dbName, path: this.dbPath});
    }
};